<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>JVector.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.jute.compiler</a> &gt; <span class="el_source">JVector.java</span></div><h1>JVector.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.jute.compiler;

/**
 *
 */
public class JVector extends JCompType {
    
<span class="nc" id="L26">    static private int level = 0;</span>
    
<span class="nc" id="L28">    static private String getId(String id) { return id+getLevel(); }</span>
    
<span class="nc" id="L30">    static private String getLevel() { return Integer.toString(level); }</span>
    
<span class="nc" id="L32">    static private void incrLevel() { level++; }</span>
    
<span class="nc" id="L34">    static private void decrLevel() { level--; }</span>
    
    private JType mElement;
    
    /** Creates a new instance of JVector */
    public JVector(JType t) {
<span class="nc" id="L40">        super(&quot;struct &quot; + extractVectorName(t), &quot; ::std::vector&lt;&quot;+t.getCppType()+&quot;&gt;&quot;, &quot;System.Collections.Generic.List&lt;&quot; + t.getCsharpType() + &quot;&gt;&quot;, &quot;java.util.List&lt;&quot; + t.getJavaType() + &quot;&gt;&quot;, &quot;Vector&quot;,</span>
<span class="nc" id="L41">                &quot;System.Collections.Generic.List&lt;&quot; + t.getCsharpType() + &quot;&gt;&quot;, &quot;java.util.ArrayList&lt;&quot; + t.getJavaType() + &quot;&gt;&quot;);</span>
<span class="nc" id="L42">        mElement = t;</span>
<span class="nc" id="L43">    }</span>
    
    public String getSignature() {
<span class="nc" id="L46">        return &quot;[&quot; + mElement.getSignature() + &quot;]&quot;;</span>
    }
    
    public String genJavaCompareTo(String fname) {
<span class="nc" id="L50">        return &quot;    throw new UnsupportedOperationException(\&quot;comparing &quot;</span>
            + fname + &quot; is unimplemented\&quot;);\n&quot;;
    }
    
    public String genJavaReadWrapper(String fname, String tag, boolean decl) {
<span class="nc" id="L55">        StringBuilder ret = new StringBuilder(&quot;&quot;);</span>
<span class="nc bnc" id="L56" title="All 2 branches missed.">        if (decl) {</span>
<span class="nc" id="L57">            ret.append(&quot;      java.util.List &quot;+fname+&quot;;\n&quot;);</span>
        }
<span class="nc" id="L59">        ret.append(&quot;    {\n&quot;);</span>
<span class="nc" id="L60">        incrLevel();</span>
<span class="nc" id="L61">        ret.append(&quot;      Index &quot;+getId(&quot;vidx&quot;)+&quot; = a_.startVector(\&quot;&quot;+tag+&quot;\&quot;);\n&quot;);</span>
<span class="nc" id="L62">        ret.append(&quot;      if (&quot;+getId(&quot;vidx&quot;)+&quot;!= null) {&quot;);</span>
<span class="nc" id="L63">        ret.append(&quot;          &quot;+fname+&quot;=new java.util.ArrayList&lt;&quot;+ mElement.getJavaType() + &quot;&gt;();\n&quot;);</span>
<span class="nc" id="L64">        ret.append(&quot;          for (; !&quot;+getId(&quot;vidx&quot;)+&quot;.done(); &quot;+getId(&quot;vidx&quot;)+&quot;.incr()) {\n&quot;);</span>
<span class="nc" id="L65">        ret.append(mElement.genJavaReadWrapper(getId(&quot;e&quot;), getId(&quot;e&quot;), true));</span>
<span class="nc" id="L66">        ret.append(&quot;            &quot;+fname+&quot;.add(&quot;+getId(&quot;e&quot;)+&quot;);\n&quot;);</span>
<span class="nc" id="L67">        ret.append(&quot;          }\n&quot;);</span>
<span class="nc" id="L68">        ret.append(&quot;      }\n&quot;);</span>
<span class="nc" id="L69">        ret.append(&quot;    a_.endVector(\&quot;&quot;+tag+&quot;\&quot;);\n&quot;);</span>
<span class="nc" id="L70">        decrLevel();</span>
<span class="nc" id="L71">        ret.append(&quot;    }\n&quot;);</span>
<span class="nc" id="L72">        return ret.toString();</span>
    }
    
    public String genJavaReadMethod(String fname, String tag) {
<span class="nc" id="L76">        return genJavaReadWrapper(fname, tag, false);</span>
    }
    
    public String genJavaWriteWrapper(String fname, String tag) {
<span class="nc" id="L80">        StringBuilder ret = new StringBuilder(&quot;    {\n&quot;);</span>
<span class="nc" id="L81">        incrLevel();</span>
<span class="nc" id="L82">        ret.append(&quot;      a_.startVector(&quot;+fname+&quot;,\&quot;&quot;+tag+&quot;\&quot;);\n&quot;);</span>
<span class="nc" id="L83">        ret.append(&quot;      if (&quot;+fname+&quot;!= null) {&quot;);</span>
<span class="nc" id="L84">        ret.append(&quot;          int &quot;+getId(&quot;len&quot;)+&quot; = &quot;+fname+&quot;.size();\n&quot;);</span>
<span class="nc" id="L85">        ret.append(&quot;          for(int &quot;+getId(&quot;vidx&quot;)+&quot; = 0; &quot;+getId(&quot;vidx&quot;)+&quot;&lt;&quot;+getId(&quot;len&quot;)+&quot;; &quot;+getId(&quot;vidx&quot;)+&quot;++) {\n&quot;);</span>
<span class="nc" id="L86">        ret.append(&quot;            &quot;+mElement.getJavaWrapperType()+&quot; &quot;+getId(&quot;e&quot;)+&quot; = (&quot;+mElement.getJavaWrapperType()+&quot;) &quot;+fname+&quot;.get(&quot;+getId(&quot;vidx&quot;)+&quot;);\n&quot;);</span>
<span class="nc" id="L87">        ret.append(mElement.genJavaWriteWrapper(getId(&quot;e&quot;), getId(&quot;e&quot;)));</span>
<span class="nc" id="L88">        ret.append(&quot;          }\n&quot;);</span>
<span class="nc" id="L89">        ret.append(&quot;      }\n&quot;);</span>
<span class="nc" id="L90">        ret.append(&quot;      a_.endVector(&quot;+fname+&quot;,\&quot;&quot;+tag+&quot;\&quot;);\n&quot;);</span>
<span class="nc" id="L91">        ret.append(&quot;    }\n&quot;);</span>
<span class="nc" id="L92">        decrLevel();</span>
<span class="nc" id="L93">        return ret.toString();</span>
    }
    
    public String genJavaWriteMethod(String fname, String tag) {
<span class="nc" id="L97">        return genJavaWriteWrapper(fname, tag);</span>
    }
    
    public JType getElementType() {
<span class="nc" id="L101">    	return mElement;</span>
    }

    public String genCsharpWriteWrapper(String fname, String tag) {
<span class="nc" id="L105">        StringBuilder ret = new StringBuilder(&quot;    {\n&quot;);</span>
<span class="nc" id="L106">        incrLevel();</span>
<span class="nc" id="L107">        ret.append(&quot;      a_.StartVector(&quot;+capitalize(fname)+&quot;,\&quot;&quot;+tag+&quot;\&quot;);\n&quot;);</span>
<span class="nc" id="L108">        ret.append(&quot;      if (&quot;+capitalize(fname)+&quot;!= null) {&quot;);</span>
<span class="nc" id="L109">        ret.append(&quot;          int &quot;+getId(&quot;len&quot;)+&quot; = &quot;+capitalize(fname)+&quot;.Count;\n&quot;);</span>
<span class="nc" id="L110">        ret.append(&quot;          for(int &quot;+getId(&quot;vidx&quot;)+&quot; = 0; &quot;+getId(&quot;vidx&quot;)+&quot;&lt;&quot;+getId(&quot;len&quot;)+&quot;; &quot;+getId(&quot;vidx&quot;)+&quot;++) {\n&quot;);</span>
<span class="nc" id="L111">        ret.append(&quot;            &quot;+mElement.getCsharpWrapperType()+&quot; &quot;+getId(&quot;e&quot;)+&quot; = (&quot;+mElement.getCsharpWrapperType()+&quot;) &quot;+capitalize(fname)+&quot;[&quot;+getId(&quot;vidx&quot;)+&quot;];\n&quot;);</span>
<span class="nc" id="L112">        ret.append(mElement.genCsharpWriteWrapper(getId(&quot;e&quot;), getId(&quot;e&quot;)));</span>
<span class="nc" id="L113">        ret.append(&quot;          }\n&quot;);</span>
<span class="nc" id="L114">        ret.append(&quot;      }\n&quot;);</span>
<span class="nc" id="L115">        ret.append(&quot;      a_.EndVector(&quot;+capitalize(fname)+&quot;,\&quot;&quot;+tag+&quot;\&quot;);\n&quot;);</span>
<span class="nc" id="L116">        ret.append(&quot;    }\n&quot;);</span>
<span class="nc" id="L117">        decrLevel();</span>
<span class="nc" id="L118">        return ret.toString();</span>
    }

    String genCsharpWriteMethod(String fname, String tag) {
<span class="nc" id="L122">        return genCsharpWriteWrapper(fname, tag);</span>
    }

    public String genCsharpReadWrapper(String fname, String tag, boolean decl) {
<span class="nc" id="L126">        StringBuilder ret = new StringBuilder(&quot;&quot;);</span>
<span class="nc bnc" id="L127" title="All 2 branches missed.">        if (decl) {</span>
<span class="nc" id="L128">            ret.append(&quot;      System.Collections.Generic.List&lt;&quot; + mElement.getCsharpType()+ &quot;&gt; &quot;+capitalize(fname)+&quot;;\n&quot;);</span>
        }
<span class="nc" id="L130">        ret.append(&quot;    {\n&quot;);</span>
<span class="nc" id="L131">        incrLevel();</span>
<span class="nc" id="L132">        ret.append(&quot;      IIndex &quot;+getId(&quot;vidx&quot;)+&quot; = a_.StartVector(\&quot;&quot;+tag+&quot;\&quot;);\n&quot;);</span>
<span class="nc" id="L133">        ret.append(&quot;      if (&quot;+getId(&quot;vidx&quot;)+&quot;!= null) {&quot;);</span>
<span class="nc" id="L134">        ret.append(&quot;          &quot;+capitalize(fname)+&quot;=new System.Collections.Generic.List&lt;&quot;+ mElement.getCsharpType() + &quot;&gt;();\n&quot;);</span>
<span class="nc" id="L135">        ret.append(&quot;          for (; !&quot;+getId(&quot;vidx&quot;)+&quot;.Done(); &quot;+getId(&quot;vidx&quot;)+&quot;.Incr()) {\n&quot;);</span>
<span class="nc" id="L136">        ret.append(mElement.genCsharpReadWrapper(getId(&quot;e&quot;), getId(&quot;e&quot;), true));</span>
<span class="nc" id="L137">        ret.append(&quot;            &quot;+capitalize(fname)+&quot;.Add(&quot;+getId(&quot;e&quot;)+&quot;);\n&quot;);</span>
<span class="nc" id="L138">        ret.append(&quot;          }\n&quot;);</span>
<span class="nc" id="L139">        ret.append(&quot;      }\n&quot;);</span>
<span class="nc" id="L140">        ret.append(&quot;    a_.EndVector(\&quot;&quot;+tag+&quot;\&quot;);\n&quot;);</span>
<span class="nc" id="L141">        decrLevel();</span>
<span class="nc" id="L142">        ret.append(&quot;    }\n&quot;);</span>
<span class="nc" id="L143">        return ret.toString();</span>
    }
    
    String genCsharpReadMethod(String fname, String tag) {
<span class="nc" id="L147">        return genCsharpReadWrapper(fname, tag, false);</span>
    }

    static public String extractVectorName(JType jvType) {
<span class="nc" id="L151">		return JRecord.extractMethodSuffix(jvType)+&quot;_vector&quot;;</span>
	}
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>